#####################################################################
#     showbdf.awk  for SHIFTJIS                                     #
#                                                                   #
#  gawk --ctype=SJIS -f showbdf.awk foo.bdf                         #
#                                                                   #
#  Copyright (c) Fukai Yoshiharu 1995.12.22                         #
#               <PED00251@niftyserve.or.jp>                         #
#####################################################################

BEGIN{
	hex="0123456789abcdef";
}

{
	N=length($0);
	if($0 ~ /^[0-9a-fA-F]+$/){
		printf ("%s\t",$0);
	$0 = tolower($0);
		for(i=1;i<=N;i++){
		printf("%s",inttobit(hextoint(substr($0,i,1))));
		}
		printf("\n");
	}else print $0;
}
func inttobit(x,   bit,i) {
		bit="";
	for(i=8; i >= 1 ;i/=2){
		int(x/i) == 1 ? bit = bit "" : bit = bit ""
		x %= i;
	}
	return bit;
}	
func hextoint(h) { return match(hex,h) - 1 }
